<body>
    <div id="map" style='height:80%'></div>
    <textarea id="json_polyline" style='height:10%; width:100%'></textarea>
</body>
<!-- <script src="https://maps.googleapis.com/maps/api/js?v=3.exp">
</script> -->
<script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyCNQtfi4C8QpQHBwTMqmNOufW-lPrPn-i8">
</script>
<script> 
var mapOptions = {
        zoom: 3,
        center: new google.maps.LatLng(0, 60),
    }

var map = new google.maps.Map(document.getElementById('map'), mapOptions);

function initialize() {
	

    var polyOptions = {
        geodesic: false,
        strokeColor: '#FF0000',
        strokeOpacity: 1.0,
        strokeWeight: 2,
        editable: true,
    }
    var poly = new google.maps.Polyline(polyOptions);
    poly.setMap(map);

    //Call draw area here
    //drawArea();
    //markArea();
    //drawMainRoute();
    //drawShipRoute();

    google.maps.event.addListener(map, "click", function(event) {
        var path = poly.getPath();
        path.push(event.latLng);

        var coordinates_poly = poly.getPath().getArray();
        var newCoordinates_poly = [];
        for (var i = 0; i < coordinates_poly.length; i++) {
            lat_poly = coordinates_poly[i].lat();
            lng_poly = coordinates_poly[i].lng();

            latlng_poly = [lat_poly, lng_poly];
            newCoordinates_poly.push(latlng_poly);
        }
        var str_coordinates_poly = JSON.stringify(newCoordinates_poly);
        var json_poly = "{\"ToaDo\":" + str_coordinates_poly + "}";

        document.getElementById('json_polyline').value = json_poly;

    });

    function drawArea() {
        for (let i = -180; i < 180; i += 5) {
            let longitude = [
                { lat: 85, lng: i },
                { lat: -85, lng: i }
            ]

            let flightPath = new google.maps.Polyline({
                path: longitude,
                strokeColor: '#351fdb',
                strokeOpacity: 0.5,
                strokeWeight: 2
            });

            flightPath.setMap(map);
        }

        for (let i = -80; i < 90; i += 5) {
            let latitude = [
                { lat: i, lng: -180 },
                { lat: i, lng: 0 },
                { lat: i, lng: 180 }
            ]
            let flightPath = new google.maps.Polyline({
                path: latitude,
                strokeColor: '#a11cad',
                strokeOpacity: 0.5,
                strokeWeight: 2
            });

            flightPath.setMap(map);
        }
    }

    function markArea() {
        let areaLat, areaLng;
        for (let lng = -179; lng < 180; lng += 5) {
        	areaLng = Math.ceil((180-lng)/5);
            for (let lat = -81; lat < 80; lat += 5) {
            	areaLat = Math.ceil((90-lat)/5);

                let latLng = { lat: lat, lng: lng };
                let image = {
                    url: 'info.png',
                    anchor: new google.maps.Point(5, 5),
                    scaledSize: new google.maps.Size(10, 10)
                };

                let harborLocation = new google.maps.Marker({
                    position: latLng,
                    title: `AreaLat: ${areaLat} \nAreaLong: ${areaLng}`,
                    icon: image,
                    map: map
                });
            }
        }
    }

    // DANGEROUS
	function drawMainRoute(){
		fetch('http://localhost:3000/getAllVertexes')
			.then(response => response.json())
			.then(data => {
				data.forEach(vertex => {
					mark(vertex)
				})
			})
	}

	function mark(vertex) {
		let latLng = { lat: vertex.coordinate[0], lng: vertex.coordinate[1] };
        let image = {
            url: 'point.png',
            anchor: new google.maps.Point(5, 5),
            scaledSize: new google.maps.Size(10, 10)
        };

        let harborLocation = new google.maps.Marker({
            position: latLng,
            title: `ID: ${vertex._id}`,
            icon: image,
            map: map
        });
	}
}

function drawShipRoute(src, des, shipCoor = []){
	fetch('http://localhost:3000/', {
      method: 'post',
      headers: {'Content-Type': 'application/json'},
      body: JSON.stringify({
        startPort: src,
        endPort: des,
        shipCoordinate: shipCoor
      })
    })
    .then(response => response.json())
    .then(data =>{
      	//console.log(data);
      	drawLine(data);
    });
    markShip(shipCoor);
}

function getRoute(listPortName, lastVisitedPortName, shipCoor = []) {
    let apiURL = 'http://localhost:3000/getRoute' +
    						 '?listPortName=' + listPortName +
    						 '&lastVisitedPortName=' + lastVisitedPortName +
    						 '&shipCoordinate=' +shipCoor; 
    fetch(apiURL)
		.then(response => response.json())
		.then(data => {
			//console.log(data);
            drawLine(data);
            markShip(shipCoor);
		});
}

function drawLine(route){
	flightPlanCoordinates = [];
	for(i = 0; i < route.length; i++){
	    flightPlanCoordinates.push({lat: route[i][0], lng: route[i][1]});
	}

	let flightPath = new google.maps.Polyline({
	    path: flightPlanCoordinates,
	    strokeColor: '#FF0000',
	    strokeOpacity: 1.0,
	    strokeWeight: 2
		});

	flightPath.setMap(map);
}

function markShip(shipCoordinate){
  let latLng = {lat: shipCoordinate[0], lng: shipCoordinate[1]};
  let image = {
    url: 'waveship.gif',
    anchor: new google.maps.Point(25, 25),
    scaledSize: new google.maps.Size(50, 50)
  };
  const harborLocation = new google.maps.Marker({
    position: latLng, 
    icon: image,
    map: map
  });
}

google.maps.event.addDomListener(window, 'load', initialize);
</script>
